#
# Copyright (C) 2021 Associated Universities, Inc. Washington DC, USA.
#
# This file is part of NRAO Workspaces.
#
# Workspaces is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Workspaces is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Workspaces.  If not, see <https://www.gnu.org/licenses/>.
"""
Tests for Vela
"""
import argparse
from unittest.mock import MagicMock, patch

import vela.quasar as quasar

args = argparse.Namespace()


class TestQuasar:
    @patch("os.chdir")
    @patch("pathlib.Path")
    @patch("os.getcwd")
    def test_main_stdcal(self, mock_cwd, mock_path, mock_chdir):
        args.files = ["test/test.json", "test/PPR.xml"]
        args.standard_cal = True

        with patch("argparse.ArgumentParser.parse_args", MagicMock(return_value=args)) as mock_args:
            with patch("vela.emulators.CasaEmulator.run") as run:
                quasar.main()
                assert run.call_count == 1

        # reset for testing
        args.files = None
        args.standard_cal = None
